﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace ultraTreeLayoutCAS_90272_Z8P6M8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //fixed width 16            
            UltraTreeNodeColumn column0 = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[0];
            column0.LayoutInfo.OriginX = 0;
            column0.LayoutInfo.AllowCellSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column0.LayoutInfo.AllowLabelSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column0.LayoutInfo.PreferredCellSize = new Size(16, 18);
            column0.LayoutInfo.PreferredLabelSize = new Size(this.Width - 109, 0); // must be the size of column 0 and 1 combined           
            
            //Takes all remaining space
            UltraTreeNodeColumn column1 = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[1];
            column1.LayoutInfo.OriginX = 2;
            column1.LayoutInfo.AllowCellSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column1.LayoutInfo.AllowLabelSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column1.LayoutInfo.PreferredCellSize = new Size(this.Width - 125, 18);

            //invisible column
            UltraTreeNodeColumn column2 = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[2];
            column2.Visible = false;

            //fixed width 20
            UltraTreeNodeColumn column3 = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[3];
            column3.LayoutInfo.AllowCellSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column3.LayoutInfo.AllowLabelSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column3.LayoutInfo.PreferredCellSize = new Size(20, 18);
            column3.LayoutInfo.PreferredLabelSize = new Size(20, 0);

            //fixed width 20
            UltraTreeNodeColumn column4 = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[4];
            column4.LayoutInfo.AllowCellSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column4.LayoutInfo.AllowLabelSizing = Infragistics.Win.UltraWinTree.LayoutSizing.None;
            column4.LayoutInfo.PreferredCellSize = new Size(20, 18);
            column4.LayoutInfo.PreferredLabelSize = new Size(20, 0);



            column0.LayoutInfo.OriginX = 0;
            column1.LayoutInfo.OriginX = 2;
            column3.LayoutInfo.OriginX = 4;
            column4.LayoutInfo.OriginX = 6;

            column0.LayoutInfo.OriginY = 0;
            column1.LayoutInfo.OriginY = 0;
            column3.LayoutInfo.OriginY = 0;
            column4.LayoutInfo.OriginY = 0;

            column0.LayoutInfo.LabelPosition = NodeLayoutLabelPosition.None;
            column1.LayoutInfo.LabelPosition = NodeLayoutLabelPosition.None;

            UltraTreeNodeColumn unboundLabelColumn = this.ultraTree1.ColumnSettings.ColumnSets[0].Columns.Add("Unbound Label Column");
            unboundLabelColumn.LayoutInfo.OriginX = column0.LayoutInfo.OriginXResolved;
            unboundLabelColumn.LayoutInfo.OriginY = column0.LayoutInfo.OriginYResolved;
            unboundLabelColumn.LayoutInfo.SpanX = column0.LayoutInfo.SpanX + column1.LayoutInfo.SpanX;
            unboundLabelColumn.LayoutInfo.LabelPosition = NodeLayoutLabelPosition.LabelOnly;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }

        private void ultraTree1_Resize(object sender, EventArgs e)
        {
            // I skipped modifing this
            this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[1].LayoutInfo.PreferredCellSize = new Size(this.Width - 125, 18);
            this.ultraTree1.ColumnSettings.ColumnSets[0].Columns[1].LayoutInfo.PreferredLabelSize = new Size(this.Width - 125, 0);
        }
    }
}
